#!/bin/bash

#export http_proxy=http://192.168.26.27:3128

CLIENT()
{
echo
echo -e "     \e[37;44m\033[1mПрограмма установки LDAP-клиента\e[00m"
echo
echo -e "\e[00;31m\033[1mСейчас Вам нужно будет ответить на несколько вопросов\e[00m"
#############################################################################
echo -e "1. \e[00;34m\033[1mВведите имя домена"
echo -e "например: lyceum130.ru"
echo -ne "\e[37;44mDOMAIN:\e[00m "
read DOMAIN
if [ "$DOMAIN" == "" ]
then
 echo -e "\e[00;31mERROR: Неверный формат. Пустая строка\e[00m"
 exit 0
fi

DOMAIN_TOK=`echo "$DOMAIN" | tr '.' ' '`
n=0
for i in $DOMAIN_TOK
do
    if [ $n == 0 ]; then
      LDAP_DOMAIN="dc="$i
      DOMAIN_FIRST_TOK=$i
      n=2
    else
      LDAP_DOMAIN=$LDAP_DOMAIN",dc="$i
    fi
done
echo -e "Имя LDAP-домена: $LDAP_DOMAIN"

#############################################################################

echo
echo -e "2. \e[00;34m\033[1mВведите ip-адрес LDAP-сервера"
echo -e "например: 192.168.0.1"
echo -ne "\e[37;44mIP-addr:\e[00m "
read IPADDR
if [ "$IPADDR" == "" ]
then
 echo -e "\e[00;31mERROR: Неверный формат. Пустая строка\e[00m"
 exit 0
fi

#############################################################################

echo
echo -e "3. \e[00;34m\033[1mВведите имя администратора домена"
echo -e "или нажмите Enter для admin"
echo -ne "\e[37;44mADMIN:\e[00m "
read ADMIN
if [ "$ADMIN" == "" ];then
ADMIN="admin"
fi
LDAP_ADMIN="cn="$ADMIN","$LDAP_DOMAIN
echo $LDAP_ADMIN

#############################################################################

echo
echo -e "4. \e[00;34m\033[1mВведите пароль администратора домена"
echo -ne "\e[37;44mPASSWORD:\e[00m "
read PASSWORD
echo
if [ "$PASSWORD" == "" ]
then
 echo -e "\e[00;31m\033[1mERROR: Пароль должен содержать хотябы 1 символ ))\e[00m"
 exit 0
fi

#############################################################################

echo
echo -e "5. \e[00;34m\033[1mУстановка необходимого програмного обеспечения"
echo -e "Для установки требуется наличие подлюченя к сети интернет"
echo -en "Для продолжения нажмите Enter:\e[00m "
read ENTER
apt-get update
apt-get -y --force-yes install libnss-ldap libpam-ldap nscd


echo
echo -e "\e[37;31m\033[1mВ вашей системе установлено необходимое програмное обеспечение\e[00m"
echo

#############################################################################

echo -e "6. \e[00;34m\033[1mНастройка програмного обеспечения"
echo -e "\e[37;44m\033[1mLDAP-домен:                \e[00;32m\033[1m$LDAP_DOMAIN"
echo -e "\e[37;44mip-адрес LDAP-сервера:     \e[00;32m\033[1m$IPADDR"
echo -e "\e[37;44mАдминистратор LDAP-домена: \e[00;32m\033[1m$LDAP_ADMIN"
echo -e "\e[37;44mПароль администратора:     \e[00;32m\033[1m$PASSWORD\e[00m"
echo
echo -e "\e[37;31m\033[1mПроверьте данные LDAP-сервера. Если они верны нажмите Y"
echo -ne "\e[37;44mCONFIRM:\e[00m "
read CONFIRM

if [ "$CONFIRM" == "Y" ] || [ "$CONFIRM" == "y" ] || [ "$CONFIRM" == "Д" ] || [ "$CONFIRM" == "д" ];then
tar -cf backup.tar /etc/ldap/ldap.conf /etc/ldap.* /etc/nsswitch.conf /etc/pam.d/common-*
gzip -9 backup.tar
echo -e "BASE\t$LDAP_DOMAIN\nURI\tldap://$IPADDR" > /etc/ldap/ldap.conf
echo -e "host $IPADDR\n\nbase $LDAP_DOMAIN\n\nldap_version 3\n\nnss_base_passwd\t\tou=Users,$LDAP_DOMAIN?one\nnss_base_passwd\t\tou=Computers,$LDAP_DOMAIN?one\nnss_base_group\t\tou=Groups,$LDAP_DOMAIN?one\n\nssl no\npam_password md5\nbind_polycy soft\nrootbinddn $LDAP_ADMIN\n\nnss_initgroups_ignoreusers backup,bin,bind,daemon,games,gnats,irc,landscape,libuuid,list,lp,mail,man,news,proxy,root,sshd,sync,sys,syslog,uucp,www-data\n" > /etc/ldap.conf
echo -e $PASSWORD > /etc/ldap.secret
echo -e "passwd:\t\tfiles ldap\ngroup:\t\tfiles ldap\nshadow:\t\tfiles ldap\n\nhosts:\t\tfiles dns\nnetworks:\tfiles\n\nprotocols:\tdb files\nservices:\tdb files\nethers:\t\tdb files\nrpc:\t\tdb files\n\nnetgroup:\tnis\n" > /etc/nsswitch.conf
echo -e "account\t\tsufficient\tpam_unix.so\naccount\t\trequired\tpam_ldap.so debug\n" > /etc/pam.d/common-account
echo -e "auth\t\tsufficient\tpam_unix.so\nauth\t\trequired\tpam_ldap.so use_first_pass debug\n" > /etc/pam.d/common-auth
echo -e "password\tsufficient\tpam_unix.so md5 shadow nullok try_first_pass use_authok\npassword\trequired\tpam_ldap.so use_authok debug\n" > /etc/pam.d/common-password
echo -e "session\t\tsufficient\tpam_unix.so\nsession\t\trequired\tpam_ldap.so debug\nsession\t\trequired\tpam_mkhomedir.so umask=0022 skel=/etc/skel/ silent\n" > /etc/pam.d/common-session
fi


}

SERVER()
{
echo
echo -e "     \e[37;44m\033[1mПрограмма установки LDAP-сервера\e[00m"
echo
echo -e "\e[00;31m\033[1mСейчас Вам нужно будет ответить на несколько вопросов\e[00m"
echo -e "1. \e[00;34m\033[1mВведите имя домена"
echo -e "например: lyceum130.ru"
echo -ne "\e[37;44mDOMAIN:\e[00m "
read DOMAIN
if [ "$DOMAIN" == "" ]
then
 echo -e "\e[00;31mERROR: Неверный формат. Пустая строка\e[00m"
 exit 0
fi

DOMAIN_TOK=`echo "$DOMAIN" | tr '.' ' '`
n=0
for i in $DOMAIN_TOK
do
    if [ $n == 0 ]; then
      LDAP_DOMAIN="dc="$i
      DOMAIN_FIRST_TOK=$i
      n=2
    else
      LDAP_DOMAIN=$LDAP_DOMAIN",dc="$i
    fi
done
echo -e "Имя LDAP-домена: $LDAP_DOMAIN"

echo
echo -e "2. \e[00;34m\033[1mВведите имя администратора домена"
echo -e "или нажмите Enter для admin"
echo -ne "\e[37;44mADMIN:\e[00m "
read ADMIN
if [ "$ADMIN" == "" ];then
ADMIN="admin"
fi
LDAP_ADMIN="cn="$ADMIN","$LDAP_DOMAIN
echo $LDAP_ADMIN
echo
echo -e "3. \e[00;34m\033[1mВведите пароль администратора домена"
echo -ne "\e[37;44mPASSWORD:\e[00m "
read PASSWORD
echo
if [ "$PASSWORD" == "" ]
then
 echo -e "\e[00;31m\033[1mERROR: Пароль должен содержать хотябы 1 символ ))\e[00m"
 exit 0
fi

echo
echo -e "4. \e[00;34m\033[1mУстановка необходимого програмного обеспечения"
echo -e "Для установки требуется наличие подлюченя к сети интернет"
echo -en "Для продолжения нажмите Enter:\e[00m "
read ENTER
apt-get update
apt-get -y --force-yes install ldap-server ldap-utils

SSHA_PASSWORD=`slappasswd -s "$PASSWORD"`
echo
echo -e "\e[37;31m\033[1mВ вашей системе установлено необходимое програмное обеспечение\e[00m"
echo

echo -e "5. \e[00;34m\033[1mПервичная настройка програмного обеспечения"
echo -en "Для продолжения нажмите Enter:\e[00m "
read ENTER
LDIF_FILE_PREFIX=`date +%s`
echo -e "dn: cn=module{0},cn=config\nobjectClass: olcModuleList\ncn: module\nolcModulepath: /usr/lib/ldap\nolcModuleload: {0}back_hdb\n\ndn: olcDatabase={1}hdb,cn=config\nobjectClass: olcDatabaseConfig\nobjectClass: olcHdbConfig\nolcDatabase: {1}hdb\nolcDbDirectory: /var/lib/ldap\nolcSuffix: $LDAP_DOMAIN\nolcRootDN: $LDAP_ADMIN\nolcRootPW: $PASSWORD\nolcDbConfig: {0}set_cachesize 0 2097152 0\nolcDbConfig: {1}set_lk_max_objects 1500\nolcDbConfig: {2}set_lk_max_locks 1500\nolcDbConfig: {3}set_lk_max_lockers 1500\nolcLastMod: TRUE\nolcDbCheckpoint: 512 30\nolcDbIndex: uid pres,eq\nolcDbIndex: cn,sn,mail pres,eq,approx,sub\nolcDbIndex: objectClass eq\n" > init_$LDIF_FILE_PREFIX.ldif
echo -e "dn: $LDAP_DOMAIN\nobjectClass: dcObject\nobjectclass: organization\no: $DOMAIN\ndc: $DOMAIN_FIRST_TOK\ndescription: My LDAP Root\n\ndn: $LDAP_ADMIN\nobjectClass: simpleSecurityObject\nobjectClass: organizationalRole\ncn: $ADMIN\nuserPassword: $SSHA_PASSWORD\ndescription: LDAP administrator\n" >> init_$LDIF_FILE_PREFIX.ldif
echo -e "dn: olcDatabase={-1}frontend,cn=config\nchangetype: modify\ndelete: olcAccess\n\ndn: olcDatabase={0}config,cn=config\nchangetype: modify\nadd: olcRootDN\nolcRootDN: cn=$ADMIN,cn=config\n\ndn: olcDatabase={0}config,cn=config\nchangetype: modify\nadd: olcRootPW\nolcRootPW: $SSHA_PASSWORD\n\ndn: olcDatabase={0}config,cn=config\nchangetype: modify\ndelete: olcAccess" >> init_$LDIF_FILE_PREFIX.ldif
echo -e "dn: olcDatabase={1}hdb,cn=config\nadd: olcAccess\nolcAccess: to attrs=userPassword,shadowLastChange by dn=\"$LDAP_ADMIN\" write by anonymous auth by self write by * none\nolcAccess: to dn.base=\"\" by * read\nolcAccess: to * by dn=\"$LDAP_ADMIN\" write by * read\n" > init_r_$LDIF_FILE_PREFIX.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/cosine.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/inetorgperson.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/nis.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/openldap.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/misc.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f init_$LDIF_FILE_PREFIX.ldif
ldapmodify -x -w $PASSWORD -D cn=$ADMIN,cn=config -f init_r_$LDIF_FILE_PREFIX.ldif

echo
echo -e "Теперь сервер LDAP настроен и доступен для подключения"
for i in `ifconfig | grep 'inet ' | tr ':' ' ' | awk '{print $3}'`; do
  IP=$IP$i" "
done
echo -e "\e[37;44m\033[1mпо адресам:                \e[00;31m\033[1m$IP"
echo -e "\e[37;44mLDAP-домен:                \e[00;31m\033[1m$LDAP_DOMAIN"
echo -e "\e[37;44mадминистратор LDAP-домена: \e[00;31m\033[1m$LDAP_ADMIN"
echo -e "\e[37;44mпароль администратора:     \e[00;31m\033[1m$PASSWORD\e[00m"
read ENTER
rm init_$LDIF_FILE_PREFIX.ldif init_r_$LDIF_FILE_PREFIX.ldif
}

echo
echo -e "\t\e[37;44m\033[1mПрограмма для работы с LDAP\e[00m"
echo
echo -e "\e[00;31m\033[1mДля настройки LDAP-сервера введите 1"
echo -e "\e[00;31m\033[1mДля настройки LDAP-клиента введите 2"
echo -en "\e[37;44m\033[1mLADP:\e[00m "
read CASE
case "$CASE" in
1) SERVER
   ;;
2) CLIENT
   ;;
*) exit 0
   ;;
esac

